#ifndef __LYR2DEFS__
#define __LYR2DEFS__

/* lyr2defs.h
This file contains definitions for MPEG-1 audio encoding layer II
(see ISO\IEC 11172-3)
*/

#define SUBBANDS 32
#define GROUPSIZE 12
#define NUMGROUPS 3
#define VECTORS (GROUPSIZE*NUMGROUPS)
#define INPUTSIZE (SUBBANDS*GROUPSIZE*NUMGROUPS)

//the following enums are duplicated in the dll interface include files
//audioenc.h and rcuser.h
enum EStereoType {STEREO, JOINT_STEREO, DUAL_CHANNEL, MONO};
enum ESamplingFreq {SF_44100_HZ, SF_48000_HZ, SF_32000_HZ, SF_22050_HZ, SF_11025_HZ};

#ifndef min 
inline int min (int x, int y) {return (x > y) ? y : x;};
inline float min (float x, float y) {return (x > y) ? y : x;};
#endif

#ifndef max 
inline int max (int x, int y) {return (x < y) ? y : x;};
inline float max (float x, float y) {return (x < y) ? y : x;};
#endif

typedef unsigned char BYTE;

#endif //#ifndef __LYR2DEFS__
