#ifndef __RCOPS_H__
#define __RCOPS_H__

#include "bwuser.h"	   //for now we use same structures as original HW




typedef enum 
{
    StandardMix = 0,
    NoMix = 1,
    VideoCDMix = 2
}EStreamMixType;

/*
 * The mode defines whether a dialog to be displayed, the saved
 * settings fetched from the registry, or the current settings
 * modified but not written to the registry.
 * 
 */ 
#define MODE_MODIFY_CURRENT			0      
#define MODE_FETCH_SETTINGS			1      
#define MODE_DISPLAY_DIALOG			2
#define MODE_MODIFY_PLAYBACKTARGET	3

 
typedef struct _BW_RECODEOPTIONS 
{
	// dialog information 
    unsigned long ulStructSize; // size of this structure
    long nMode;					// dialog mode
    HWND hWndParent;			// parent window

	// fixed settings taken from mpegtype.ini 
	long nEncodeUseOptimumRate;	// TRUE=use optimum rate; FALSE=use specified rate
	long nEncodeStreamDataRate;	// total stream data rate
	long nEncodePackSize;		// pack size
	long nEncodePacketsPerPack;	// packets per pack
//	EStreamMixType nStreamMixType;		// stream mix type
	
	// user selectable settings 
	BW_RECODE_PREFERENCES *lpPreferences;	 //defined in bwuser.h

} BW_RECODEOPTIONS;

#endif //#ifndef __RCOPS_H__
