/*               %W% %G%                              */
/**************************************************************************
 *
 * FILE        tvida.h 
 * 
 * PURPOSE     test cl4000/cl4010 videoA port by acquiring a frame
 *
 * (C) Copyright 1993 - C-Cube Microsystems - All rights reserved
 *
 **************************************************************************/
#include "stdincs.h"

#include <stdio.h>
#include <windows.h>
#include <winbase.h>
//#include "dt_scorp.h"
#include "mcode.h"
#include "sc_def.h"
//#include "vt_helper.h"
//#include "4000_pri.h"
#include "4000_reg.h"
//#include "4000_rcp.h"

/*                        %W% %G%                     */ 
/******************************************************************************
 *
 * FILE        vida.h 
 * PURPOSE      
 *
 * (C) Copyright 1993 - C-Cube Microsystems - All rights reserved
 *
 **************************************************************************/

#ifndef _VIDA_H_

#define _VIDA_H_

/*------------------------------------------------------------*/
/*  VideoA Input VACTL Register Definations
/*------------------------------------------------------------*/
#define VCTL_PASS_THRU     0L
#define VCTL_CIF_DEC       1L
#define VCTL_YCC_SEP       2L
#define VCTL_601_FILT      3L

#define VCTL_LUMA_ONLY     4L
#define VCTL_DATA_OUT      8L
#define VCTL_16_BIT        16L

/*------------------------------------------------------------*/
/*  SMEM Locations (used by microcode)
/*------------------------------------------------------------*/

#define SA_VIDIN_DST	(0x06 << 2)
#define SA_VIDIN_DST1	(0x07 << 2)
#define SA_VIDIN_DST2	(0x08 << 2)

#define SA_VACTL_MODE   (0x09 << 2)
#define SA_LINE_INC     (0x0A << 2)

#define SA_R24	0xeec
#define SA_R25	0xef0
#define SA_R26	0xef4
#define SA_R27	0xef8



/*------------------------------------------------------------*/
/* DRAM Locations (used by microcode)
/*------------------------------------------------------------*/

#define DA_VA_MODE	(0x100L << 2) 
#define DA_HRES    	(0x101L << 2)
#define DA_VRES    	(0x102L << 2)
#define DA_START    	(0x103L << 2)

#define DA_VSYNC_CTR	(0x104L << 2)
#define VIDLINE_NUM     (0x105L << 2)
#define VIDLINE_NUM2	(0x106L << 2)

#define DEBUG1          (0x108L << 2)
#define DEBUG2          (0x109L << 2)
#define DEBUG3          (0x10AL << 2)
#define DEBUG4		(0x10BL << 2)

/*
 *  DRAM Buffers for input data 
 *    - 704x240 buffer is 0x14A00 words 
 *    - 352x240 buffers sare 0xA500 words
 */

#define VIDLINE_BUF_DADR       (0x10000L << 2)   
#define VIDLINE_BUF2_DADR      (0x30000L << 2)   
#endif // vida.h defined ifdef 



#include "capframe.h"


/************************************************************************
 *									*
 * test videoA port by running program on cl4000 that will grab 1 frame *
 * into memory                                                          *
 *									*
 ************************************************************************/
/*************************************************************************
 *
 * (C) Copyright 1993 - C-Cube Microsystems - All rights reserved
 *
 **************************************************************************/
#if 0
#include <stdio.h>
#include <fcntl.h>

#include "sc_def.h"
#include "dtdefs.h"
#include "dt_scorp.h"

//#include "4000_pri.h"
#include "4000_reg.h"
//#include "4000_rcp.h"

#define DMA_MODE_9_SCV	0x01000000L
#define DMA_MODE_8_CHP	0x00000000L
#define DMA_MODE_9_CHP	0x00000040L
#endif
/*-----------------------------------------------------------------------*/
/* This function configures the VRP's DMAMODE register to set the dram
/*  page size.  The dram page size must be set properly to 8/9/10 bit
/*  depending on the type of drams being used by the system.  This must
/*  be done before the microcode is downloaded and the chip begins 
/*  execution.
/*  
/*  On the Scorpio and Jupiter Boards, the DRAM page size can be determined
/*  by reading the board-level SCV register and looking at the bits [28,29]
/*  
/*  On customer systmes this function can be hard-coded to the dram type
/*  being used.
/*
/*  Note PROPER PORTING OF THIS FUNCTION IS CRITICAL!
/*-----------------------------------------------------------------------*/

int c3_reset_part1(PREGS chip)
{

  reset(chip);
  imemClear(chip);
    
  imemWrite(chip,0x10,0x8c0);
  run_inst(chip,32);
  imemWrite(chip,0x10,0);
  reset(chip);
  smemClear(chip);
    
  /*  Enable DMA Unit (Normal, Interleaved, Refr Count = 0x100). */
    GBusWrite(chip,GBUS_DMAMODE,VIDTOOL_MEMCONFIG);
  
  /*  Reset Vlc_Start register. */
  GBusWrite(chip,GBUS_VLCSTART,0x0);
  
  /*  Reset then turn On VLC Unit (MPEG, Intra, empty PACK & ZZ). */
  GBusWrite(chip,GBUS_VLCCTL,0x00080105);
  GBusWrite(chip,GBUS_VLCCTL,0xc0080105);

  /*  Enable CPU module (reset Ghalt, Greset), set PIO as input. */
  WBusWrite(chip,WBUS_CPUCTL,0xc0000000);
  
  /*  Dummy VLD transfer to disable VLD. */
  WBusWrite(chip,WBUS_CHMEM5,0x07840002);
  
  /*
   * set a breakpoint
   * run for awhile to initialize the VLD
   * then reset the chip. 
   */
  GBusWrite(chip,0x24,0x20);
  GBusWrite(chip,0x24,0x0);
    
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);

  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
    
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  GBusWrite(chip,GBUS_VLDDATA,0x0);
  

  /*  VLD initialized: start again. */
  reset(chip);                             

  rmemClear(chip);

  /* initialize rmem locations - MUST BE DONE BEFORE INITIALIZING IMEM! */
 return VT_NO_ERROR; 
}


int c3_reset_part2(PREGS chip)
{

  /* CpuWritePC(chip, 0, 0, 0);        /**** tfifo.c ****/
  
  /* Initialize ME MemCtl */
  GBusWrite(chip,GBUS_MEMEMCTL,0xc0000040);    

  /* Clear Host semaphore bit */
  GBusWrite(chip,GBUS_SEMA,0x0);               

  /* Disable all INTs. */    
  WBusWrite(chip,WBUS_INTCTL,0xfffefffe);      
   
  /* Reset Mul_Cntl Reg (clip 9) */
  WBusWrite(chip,WBUS_MULCTL,0x4);             
  
  /*
   * Enable DMA Unit 
   * (Normal, Interleaved, 8 or 9-bit page, Refr Count = 0x100) 
   */
    //GBusWrite(chip,GBUS_DMAMODE,VIDTOOL_MEMCONFIG);
	GBusWrite(chip,GBUS_DMAMODE,0xc9000000L | DMA_MODE_9_CHP);
	//GBusWrite(chip,GBUS_DMAMODE,0xc8800000L | DMA_MODE_9_CHP);

	/* Reset Vlc_Start register. */
  GBusWrite(chip,GBUS_VLCSTART,0x0);
  
  /* turn on VLC unit (MPEG, Intra, empty PACK & ZZ) */
  GBusWrite(chip,GBUS_VLCCTL,0x00080105);
  GBusWrite(chip,GBUS_VLCCTL,0xc0080105);
  
  /* Zero out VLC Pack register, 
   * enable CPU module (reset Ghalt, Greset), set PIO as input, 
   */
  WBusWrite(chip,WBUS_CPUPACK,0x0);
  WBusWrite(chip,WBUS_CPUCTL,0xc0000000);
  
  /* enable smem, refresh and VLC */
  WBusWrite(chip,WBUS_INTCTL,0x00010201);
  
  /* setup VLC DMA */
  WBusWrite(chip ,WBUS_CHMEM5,0xff980003);   
  
  /*  set the chipid */
  GBusWrite(chip,GBUS_HCTL,0x50001000 + (CHIP_ID << 4));
    
  /* start the chip executing  */
  GBusWrite(chip,GBUS_HCTL,0xf0000000);
 return VT_NO_ERROR; 
  
}

#define VID_MODE   (VCTL_PASS_THRU | VCTL_16_BIT)              /* Scorpio */

CCapFrame::CCapFrame(DEVSTRUCT *dwDevice):CMicrocode(dwDevice)
{
	hres=704;
	vres=480;
	mode=VID_MODE;
	Dev->CaptureInfo.FrameWidth=(short)hres;
	Dev->CaptureInfo.FrameHeight=(short)vres;
}


ECODE CCapFrame::Load()
{
	PREGS chipNo=Dev->Regs;

  

  c3_reset_part1(chipNo);
  
  /* Load IMEM with actual test code */
  VT_LoadFile(Dev,VR_IMEM, "vida.imb");  

  /* setup value of DRAM for transfer */
  VT_LoadFile(Dev,VR_DRAM, "vida.dmb");   

  dramWrite(chipNo, (ulong) (DA_VA_MODE >> 2), (ulong) mode);
  dramWrite(chipNo, (ulong) (DA_HRES >> 2),    (ulong) hres);
  dramWrite(chipNo, (ulong) (DA_VRES >> 2),    (ulong) vres);
	DWORD temp;
  dramRead(chipNo,(ulong)(DA_VSYNC_CTR>>2),&temp);
  dramRead(chipNo,(ulong)(VIDLINE_NUM>>2),&temp);
  dramRead(chipNo,(ulong)(VIDLINE_NUM2>>2),&temp);


  c3_reset_part2(chipNo);

  //scorpio_wr_scv(0x90000);

  /* Trigger the frame grab */
  //dramWrite(chipNo, (ulong) (DA_START >> 2),   (ulong) 1);
  

  /*--------------------------------------------------------*/
  /* Capture Running                                           */
  /*--------------------------------------------------------*/
	return VT_NO_ERROR;
}

ECODE CCapFrame::Start()
{
  /* Trigger the frame grab */
#if 0
	Regs->Status|=VSYNC_INT_FLAG;  // clear flag
	while(!(Regs->Status & VSYNC_INT_FLAG));
	GBusWrite(GBUS_HCTL,0x50000000);  // STOP chip
	WBusRead(Regs,WBUS_CPUCTL,&value);
	GBusWrite(GBUS_HCTL,0xf0000000);  // start chip
	if (!(value & 0x100))
	{
		Regs->Status|=VSYNC_INT_FLAG;  // clear flag
		while(!(Regs->Status & VSYNC_INT_FLAG));
	}
	GBusWrite(GBUS_HCTL,0xf0000000);  // start chip
#endif
	GBusWrite(GBUS_HCTL,0x50000000);  // STOP chip
		  WBusWrite(Regs,WBUS_INTCTL,0x00010010);
	GBusWrite(GBUS_HCTL,0xf0000000);  // start chip
	return dramWrite(Dev->Regs, (ulong) (DA_START >> 2),   (ulong) 1);
}

extern char *VT_ErrorMessage;

extern "C" ECODE VT_INTERFACE VT_ReadSingleFrame(DEVID dwDevice,DWORD *FramePtr)
{
//	return (dynamic_cast<CCapFrame*>(dwDevice->MicroCode))->ReadFrame(FramePtr);
	return ((CCapFrame*)(dwDevice->MicroCode))->ReadFrame(FramePtr);
}

ECODE  CCapFrame::ReadFrame(void *FramePtr)

{
	PREGS chipNo=Dev->Regs;
	ulong	 i;
	ulong  temp1, temp2, temp3, temp4;
	  ulong  *bufptr, hsize;
	dramRead(chipNo, DEBUG1 >> 2, &temp1); 
	dramRead(chipNo, DEBUG2 >> 2, &temp2);
	dramRead(chipNo, DEBUG3 >> 2, &temp3);
	dramRead(chipNo, DEBUG4 >> 2, &temp4);

	if (temp3 < 1) {
	  VT_ErrorMessage="No frame was captured";
	  return VT_ERR_OTHER;
	}
#if 0
	dramRead(chipNo,(ulong)(VIDLINE_NUM2>>2),&temp1);
	if (temp1 == 0xffffffef) {
		Sleep(20);
		dramRead(chipNo,(ulong)(VIDLINE_NUM2>>2),&temp1);
		if (temp1 == 0xffffffef) 
		{

			VT_ErrorMessage="No frame was captured";
			return VT_ERR_OTHER;
		}
		else
		{
			VT_ErrorMessage="OK";
		}
	}
#endif
	{
		GBusWrite( GBUS_HCTL, 0x50000000);	/* halt chip */
		DWORD temp;
		  /* disable video a int */
	  WBusWrite(chipNo,WBUS_INTCTL,0x00010010);

	  dramRead(chipNo,(ulong)(DA_VSYNC_CTR>>2),&temp);
	  dramRead(chipNo,(ulong)(VIDLINE_NUM>>2),&temp);
	  dramRead(chipNo,(ulong)(VIDLINE_NUM2>>2),&temp);
	  dramWrite(chipNo,(ulong)(DA_VSYNC_CTR>>2),0);

		/*----------------------------------------------------------
		* Dump Fields
		*----------------------------------------------------------*/

		hsize = hres>>1;                    /* size in words */

		bufptr = (DWORD*)FramePtr;
		// copy and deinterleave
		for(i=0; i< vres>>1; i++) {
			VT_Read(Dev,VR_DRAM,bufptr,(VIDLINE_BUF_DADR >>2)+i*hsize,hsize);
			bufptr+=hsize;
			VT_Read(Dev,VR_DRAM,bufptr,(VIDLINE_BUF2_DADR >>2)+i*hsize,hsize);
			bufptr+=hsize;
		}
	}
	dramWrite(chipNo,(ulong)(DA_VSYNC_CTR>>2),0);
	dramWrite(chipNo, DEBUG3 >> 2,0); // clear frame count
    GBusWrite(GBUS_HCTL,0xf0000000);  // start chip
	//dramWrite(Dev->Regs, (ulong) (DA_START >> 2),   (ulong) 1);
	//Sleep(34);
#if 0
	if (temp1 == 0xffffffef) 
	{
		dramWrite(Dev->Regs, (ulong) (DA_START >> 2),   (ulong) 1);
		return VT_ERR_OTHER;
	}
	else
#endif
		return VT_NO_ERROR;
}


CDiag2::CDiag2(DEVSTRUCT *dwDevice):CMicrocode(dwDevice)
{
}

ECODE CDiag2::Load()
{
	return VT_NO_ERROR;
}
#define BLOCK_SIZE 0x400
#ifdef _DEBUG
ECODE CheckMasterErr(volatile PREGS Regs);

/* Function is in codec.cpp
{
	if (Regs->Csr & 0x10)
	{
		OutputDebugString("Master Abort\n");
		return 0xDEADDEAD;
	}
	else 
		return VT_NO_ERROR;
}
*/
#else
#define CheckMasterErr(_x) VT_NO_ERROR
#endif

#define STOP_CODE 0xb7010000

ECODE CDiag2::WriteData(const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten)
{
//    CrChange(Dev->Regs,CTRL1,0xff,0x10);
// 	CrChange(Dev->Regs,CTRL2,FIFO_MODE_MASK,FIFO_MODE_RECODE);

//   Disable dma and clear Done Flags
	DWORD PadSize;
	ReturnIfError(CheckMasterErr(Dev->Regs));
	Change32(&Dev->Regs->Csr,MSTR_MODE_MASK ,0);
	ReturnIfError(CheckMasterErr(Dev->Regs));
	// empty out fifo
	while ((Dev->Regs->Csr & FIFO_EMPTYN)) 
		PadSize=Dev->Regs->FifoData;
	Write32(&Dev->Regs->Status,DONE_FLAG_1| DONE_FLAG_2 |FIFO_OVERFLOW);
	ReturnIfError(CheckMasterErr(Dev->Regs));
	// init input buffer
	*WordsWritten=Words;
	if (Dev->FB_LinAddr!=SrcPtr)
		CopyMemory(Dev->FB_LinAddr,SrcPtr,Words*sizeof(DWORD));	
	m_Buffer1Size=Words;// +0x100; //(Words/BLOCK_SIZE+1)*BLOCK_SIZE;
	PadSize=m_Buffer1Size-Words;
	memset(Dev->FB_LinAddr+Words,0,PadSize*sizeof(DWORD));
	VT_LoadDma(Dev,MASTER1,m_Buffer1Size,Dev->FB_PhysAddr);
	m_Buffer2Phys=Dev->FB_PhysAddr+m_Buffer1Size*sizeof(DWORD);
	VT_LoadDma(Dev,MASTER2,Dev->FB_Size-m_Buffer1Size,m_Buffer2Phys);
	// now enable the master
	//Clear master 1 done
	// Wait for local ?
//	while (Dev->Regs->Csr & VRP_LOCAL)
//		Sleep(1);
#if 0 // don't bother waiting here 
	if (Dev->Regs->Csr &  VRP_LOCAL)
	{
		for (int i=0;i<200;i++)
		{
			Sleep(2);
			if (!(Dev->Regs->Csr &  VRP_LOCAL))
				break;
		}
		if (Dev->Regs->Csr &  VRP_LOCAL)
			return VT_ERR_LOCAL_TIMEOUT;
	}
#endif
	Change32(&Dev->Regs->Csr,MSTR_MODE_MASK | STOP_1DONE_IN,MSTR_INPUT | MSTR_OUTPUT |STOP_1DONE_IN);
//	Change32(&Dev->Regs->Csr, STOP_1DONE_IN,STOP_1DONE_IN); // now enable stop
	ReturnIfError(CheckMasterErr(Dev->Regs));
//	Write32(&Dev->Regs->Status,DONE_FLAG_1| DONE_FLAG_2);
//	ReturnIfError(CheckMasterErr(Dev->Regs));
//	Write32(&Dev->Regs->Status,DONE_FLAG_1);
	return VT_NO_ERROR;
}
