// mcode.h
// defineitions for vrp related stuff
#include "device.h"

#ifndef __Mcode
#define __Mcode

#define ALLOC_COMMAND(name,_size,_command)     DWORD name ## D[_size]; \
	VRP_COMMAND * ## name=(VRP_COMMAND*) & ## name ## D; 		\
	name ->size=_size;   											\
	name ->command=_command 										

#define TRUE 1
#define FALSE 0



const int MaxSimpleCommandSize=4;

class CTimeCode:public TC
{
public:
    CTimeCode(unsigned char nhours, unsigned char nminutes, unsigned char nseconds, unsigned char npictures ) 
    {  hours=nhours; minutes=nminutes;seconds=nseconds;pictures=npictures;}
	CTimeCode(TC tc) {*(DWORD *)this=*(DWORD *) &tc;}
	operator DWORD() {return *(DWORD *)this;}
	DWORD &Dword() { return *(DWORD *)this;}
 } ;


class CVrpCommand
{
public:
	 CVrpCommand(VRP_COMMAND *Cmd )	{ m_pCommand=Cmd; m_MustFree=FALSE;}
	 CVrpCommand(unsigned short size,unsigned short command) ;
	 CVrpCommand(unsigned short size,unsigned short command,CTimeCode tc) ;
	 ~CVrpCommand() { if (m_MustFree) free(m_pCommand);}
	 operator VRP_COMMAND*() {return m_pCommand;}
	 DWORD& operator [] (int ss) {return m_pCommand->params[ss];} 
	 DWORD *params() {return m_pCommand->params;}
	 DWORD &param(int ss) {return m_pCommand->params[ss];}
	 VRP_COMMAND *m_pCommand;
	 int m_MustFree;
private:
	 DWORD m_SimpleCommand[MaxSimpleCommandSize];
};

class CMicrocode
{
public:
	virtual ECODE WriteData(const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten) {return VT_ERR_UNSUPPORTED;};
	virtual ECODE ReadData(void **DestPtr, DWORD *WordsRead) {return VT_ERR_UNSUPPORTED;};
	virtual ECODE GetNextBuffer( int Type, void **BuffPtr, DWORD *SizeWords) {return VT_ERR_UNSUPPORTED;};;
//	ECODE SendMsg(int type, int length, DWORD *buf);
	CMicrocode(DEVSTRUCT *dwDevice) {Dev=(CDevice*)dwDevice;Regs=Dev->Regs;}
	virtual ~CMicrocode();
	virtual ECODE Load()=0;
	virtual ECODE Start();
	virtual ECODE Stop();
	virtual ECODE Pause();
	virtual ECODE Continue();
	virtual ECODE SetParam(DWORD param,long  value);
	virtual ECODE GetStatus(DWORD param,long *value) {return VT_ERR_UNSUPPORTED;}; 
	ECODE LoadParams(int timecode, int paramID, int data_length, ulong *data);
	ECODE SendCommand(const VRP_COMMAND *command);
	virtual ECODE SendPriorityCommand(const VRP_COMMAND *command);
protected:
	ECODE GBusRead(unsigned long addr,unsigned long *dptr)
		{return  VrpPeekNoMutex(Regs,((addr << 2) & 0x000000fc) | 0x00800000 | VRP_CHIP,dptr);}
	ECODE GBusWrite(unsigned long addr,unsigned long data)
	{return ::GBusWrite(Regs,addr,data);}
//	ECODE GBusChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) & 0x000000fc) | 0x00800000 | VRP_CHIP,_c,_d)

//	ECODE WBusRead(_a,_b,_c) VrpPeekNoMutex(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c)
//	ECODE WBusWrite(_a,_b,_c) VrpPokeNoMutex(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c)
//	ECODE WBusChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c,_d)

//	ECODE dramRead(_a,_b,_c) VrpPeekNoMutex(_a,((_b << 2) & 0x007ffffc) | VRP_CHIP,_c)
//	ECODE dramWrite(_a,_b,_c) VrpPokeNoMutex(_a,((_b << 2) &  0x007ffffc) | VRP_CHIP,_c)
//	ECODE dramChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) &  0x007ffffc) | VRP_CHIP,_c,_d)
	ECODE LoadMicrocode(char *filename);
	CDevice *Dev;
	volatile VT_REGS *Regs;
	CalcQuant(int value) ;
	ECODE SetDefaultValues(ulong timecode, int defaultSetID);

	void loadClippingTables(int horizontal, int vertical);
	void qmatrix(ulong qmatrix_addr, int quant_flag,
	     int intra_flag);
	void clipme1(ulong addr);
	static int ZigZag[8][8][2];
	static int IntraQuant[8][8];
	static int NonIntraQuant[8][8];
	static int DefaultIntraQuant[8][8];
	static int DefaultNonIntraQuant[8][8];
	DWORD m_DA_CLIPX,m_DA_CLIPY,m_DA_PTB,m_DA_BTB;
	DWORD m_ME1_CLIP_TABLE_P;
	DWORD m_ME1_CLIP_TABLE_B;
#define	M_PI 3.141592654

};


class CNoMicrocode:public CMicrocode
{
public:
	CNoMicrocode(DEVSTRUCT *dwDevice):CMicrocode(dwDevice) {} 
	virtual ECODE Load() {return VT_NO_ERROR;}
};



#endif
