// captcolr.cpp : implementation file
//

#include "stdafx.h"
#include "bwdialog.h"
#include "captcolr.h"

#include "afxpriv.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCaptureColor property page
void CCaptureColor::SetModified(BOOL bChanged)
{
	m_bChanged = bChanged;
	CPropertyPage::SetModified( bChanged );
}

IMPLEMENT_DYNCREATE(CCaptureColor, CPropertyPage)

CCaptureColor::CCaptureColor() : CPropertyPage(CCaptureColor::IDD)
{
	//{{AFX_DATA_INIT(CCaptureColor)
	//}}AFX_DATA_INIT
	m_psp.dwFlags |= PSP_HASHELP;
	m_bChanged = FALSE;
}

CCaptureColor::~CCaptureColor()
{
}

void CCaptureColor::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureColor)
	DDX_Control(pDX, IDC_COLOR_EDIT_HUE, m_edHue);
	DDX_Control(pDX, IDC_COLOR_EDIT_SATURATION, m_edSaturation);
	DDX_Control(pDX, IDC_COLOR_EDIT_INTENSITY, m_edIntensity);
	DDX_Control(pDX, IDC_COLOR_EDIT_CONTRAST, m_edContrast);
	DDX_Control(pDX, IDC_COLOR_DEFAULTS, m_Defaults);
	DDX_Control(pDX, IDC_COLOR_HUE, m_Hue);
	DDX_Control(pDX, IDC_COLOR_SATURATION, m_Saturation);
	DDX_Control(pDX, IDC_COLOR_INTENSITY, m_Intensity);
	DDX_Control(pDX, IDC_COLOR_CONTRAST, m_Contrast);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCaptureColor, CPropertyPage)
	//{{AFX_MSG_MAP(CCaptureColor)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_COLOR_DEFAULTS, OnDefaults)
	ON_EN_KILLFOCUS(IDC_COLOR_EDIT_INTENSITY, OnKillfocusEditIntensity)
	ON_EN_UPDATE(IDC_COLOR_EDIT_INTENSITY, OnUpdateEditIntensity)
	ON_EN_KILLFOCUS(IDC_COLOR_EDIT_HUE, OnKillfocusEditHue)
	ON_EN_UPDATE(IDC_COLOR_EDIT_HUE, OnUpdateEditHue)
	ON_EN_KILLFOCUS(IDC_COLOR_EDIT_CONTRAST, OnKillfocusEditContrast)
	ON_EN_UPDATE(IDC_COLOR_EDIT_CONTRAST, OnUpdateEditContrast)
	ON_EN_KILLFOCUS(IDC_COLOR_EDIT_SATURATION, OnKillfocusEditSaturation)
	ON_EN_UPDATE(IDC_COLOR_EDIT_SATURATION, OnUpdateEditSaturation)
	//}}AFX_MSG_MAP
    ON_MESSAGE( WM_COMMANDHELP, OnCommandHelp )
END_MESSAGE_MAP()

void CCaptureColor::SetItems( CSliderCtrl *pSlider, CEdit *pEdit, int nValue )
{
	pSlider->SetPos( nValue );
	
	char szText[30];

	itoa( nValue, szText, 10 );
	pEdit->SetWindowText( szText );
}
/////////////////////////////////////////////////////////////////////////////
// CCaptureColor message handlers
BOOL CCaptureColor::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	m_Hue.SetRange(0,100,TRUE);
	m_Saturation.SetRange(0,100,TRUE);
	m_Intensity.SetRange(0,100,TRUE);
	m_Contrast.SetRange(0,100,TRUE);

    m_Hue.SetTicFreq(100);
    m_Saturation.SetTicFreq(100);
    m_Intensity.SetTicFreq(100);
    m_Contrast.SetTicFreq(100);
	
    m_edHue.SetLimitText(3);
    m_edSaturation.SetLimitText(3);
    m_edIntensity.SetLimitText(3);
    m_edContrast.SetLimitText(3);
	
	int nHue = pApp->m_Settings.Hue();
	int nSaturation = pApp->m_Settings.Saturation();
	int nIntensity = pApp->m_Settings.Intensity();
	int nContrast = pApp->m_Settings.Contrast(); 

	SetItems( &m_Hue, &m_edHue, nHue );
	SetItems( &m_Saturation, &m_edSaturation, nSaturation );
	SetItems( &m_Intensity, &m_edIntensity, nIntensity );
	SetItems( &m_Contrast, &m_edContrast, nContrast );

	m_nHue = m_Hue.GetPos();
	m_nSaturation = m_Saturation.GetPos();
	m_nIntensity = m_Intensity.GetPos();
	m_nContrast = m_Contrast.GetPos();

	UINT nFilterValue = pApp->m_Settings.FilterValue();


	// TODO: Add extra initialization here
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CCaptureColor::OnKillActive( )
{
	m_nHue = m_Hue.GetPos();
	m_nSaturation = m_Saturation.GetPos();
	m_nIntensity = m_Intensity.GetPos();
	m_nContrast = m_Contrast.GetPos();


	return( TRUE );
}
	   
void CCaptureColor::OnOK( )
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

   	if (m_bChanged)
	{
		pApp->m_Settings.SetHue(m_nHue);
		pApp->m_Settings.SetSaturation(m_nSaturation);
		pApp->m_Settings.SetIntensity(m_nIntensity);
		pApp->m_Settings.SetContrast(m_nContrast);
		pApp->m_Settings.SetFilterValue(m_nFilterValue);

		SetModified( FALSE );
	}
	CPropertyPage::OnOK();
}

void CCaptureColor::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

    //handle scroll message based on source window
    HWND sourceWnd = pScrollBar->GetSafeHwnd();
    if (sourceWnd == NULL) {
        //default processing if no source
		CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
    }
	else if (sourceWnd == m_Hue.GetSafeHwnd()) {
		SetModified( TRUE );
		SetItems( &m_Hue, &m_edHue, m_Hue.GetPos() );
        pApp->m_Settings.HW_SetHue (BW_ColorToHardware(m_Hue.GetPos()));		
	}
	else if (sourceWnd == m_Saturation.GetSafeHwnd()) {
		SetModified( TRUE );
		SetItems( &m_Saturation, &m_edSaturation, m_Saturation.GetPos() );
        pApp->m_Settings.HW_SetSaturation (BW_ColorToHardware(m_Saturation.GetPos()));		
	}
	else if (sourceWnd == m_Intensity.GetSafeHwnd()) {
		SetModified( TRUE );
		SetItems( &m_Intensity, &m_edIntensity, m_Intensity.GetPos());
        pApp->m_Settings.HW_SetIntensity (BW_ColorToHardware(m_Intensity.GetPos()));		
	}
	else if (sourceWnd == m_Contrast.GetSafeHwnd()) {
		SetModified( TRUE );
		SetItems( &m_Contrast, &m_edContrast, m_Contrast.GetPos() );
        pApp->m_Settings.HW_SetContrast (BW_ColorToHardware(m_Contrast.GetPos()));		
    }
    else {
        //default processing if some other source
		CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
    }
}

BOOL CCaptureColor::DlgEqualsDefaults()
{
	UINT nHue, nSaturation, nIntensity, nContrast;
	UINT nDlgHue, nDlgSaturation, nDlgIntensity, nDlgContrast;

   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	
	nHue = pApp->m_Settings.DefaultHue();
	nSaturation = pApp->m_Settings.DefaultSaturation();
	nIntensity = pApp->m_Settings.DefaultIntensity();
	nContrast = pApp->m_Settings.DefaultContrast();
 
	nDlgHue = m_Hue.GetPos();
	nDlgSaturation = m_Saturation.GetPos();
	nDlgIntensity = m_Intensity.GetPos();
	nDlgContrast = m_Contrast.GetPos();

	if ((nHue == nDlgHue) &&
		(nSaturation == nDlgSaturation) &&
		(nIntensity == nDlgIntensity) &&
		(nContrast == nDlgContrast))
		return( TRUE );
	else
		return( FALSE );
}

void CCaptureColor::OnDefaults() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	if (!DlgEqualsDefaults())
	{
		SetItems( &m_Hue, &m_edHue, pApp->m_Settings.DefaultHue());
		SetItems( &m_Saturation, &m_edSaturation, pApp->m_Settings.DefaultSaturation());
		SetItems( &m_Intensity, &m_edIntensity, pApp->m_Settings.DefaultIntensity());
		SetItems( &m_Contrast, &m_edContrast, pApp->m_Settings.DefaultContrast());

        pApp->m_Settings.HW_SetHue (BW_ColorToHardware(m_Hue.GetPos()));		
        pApp->m_Settings.HW_SetSaturation (BW_ColorToHardware(m_Saturation.GetPos()));		
        pApp->m_Settings.HW_SetIntensity (BW_ColorToHardware(m_Intensity.GetPos()));		
        pApp->m_Settings.HW_SetContrast (BW_ColorToHardware(m_Contrast.GetPos()));		

		
		SetModified( TRUE );
	}
}


void CCaptureColor::OnKillfocusEditHue() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	int nValue, nMin, nMax;
	CString sValue;

	m_edHue.GetWindowText(sValue);
	int nLength = sValue.GetLength();

	if (nLength == 0) {
		return;
	}				
	
	nValue = strtol	(sValue, (char **)&sValue, 10);
	if (nValue == m_Hue.GetPos()) {
		return;	
	}

	m_Hue.GetRange (nMin, nMax);
	nValue = min (max (nValue, nMin), nMax);

	SetItems( &m_Hue, &m_edHue, nValue);
	SetItems( &m_Hue, &m_edHue, m_Hue.GetPos());
    pApp->m_Settings.HW_SetHue (BW_ColorToHardware(m_Hue.GetPos()));		

	SetModified( TRUE );
	
	return;
}

void CCaptureColor::OnUpdateEditHue() 
{
}

void CCaptureColor::OnKillfocusEditSaturation() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	int nValue, nMin, nMax;
	CString sValue;

	m_edSaturation.GetWindowText(sValue);
	int nLength = sValue.GetLength();

	if (nLength == 0) {
		return;
	}				
	
	nValue = strtol	(sValue, (char **)&sValue, 10);
	if (nValue == m_Saturation.GetPos()) {
		return;	
	}

	m_Saturation.GetRange (nMin, nMax);
	nValue = min (max (nValue, nMin), nMax);

	SetItems( &m_Saturation, &m_edSaturation, nValue);
	SetItems( &m_Saturation, &m_edSaturation, m_Saturation.GetPos());
    pApp->m_Settings.HW_SetSaturation (BW_ColorToHardware(m_Saturation.GetPos()));		

	SetModified( TRUE );
}

void CCaptureColor::OnUpdateEditSaturation() 
{
}

void CCaptureColor::OnKillfocusEditIntensity() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	int nValue, nMin, nMax;
	CString sValue;

	m_edIntensity.GetWindowText(sValue);
	int nLength = sValue.GetLength();

	if (nLength == 0) {
		return;
	}				
	
	nValue = strtol	(sValue, (char **)&sValue, 10);
	if (nValue == m_Intensity.GetPos()) {
		return;	
	}

	m_Intensity.GetRange (nMin, nMax);
	nValue = min (max (nValue, nMin), nMax);

	SetItems( &m_Intensity, &m_edIntensity, nValue);
	SetItems( &m_Intensity, &m_edIntensity, m_Intensity.GetPos());
    pApp->m_Settings.HW_SetIntensity (BW_ColorToHardware(m_Intensity.GetPos()));		

	SetModified( TRUE );
}

void CCaptureColor::OnUpdateEditIntensity() 
{
}						

void CCaptureColor::OnKillfocusEditContrast() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	int nValue, nMin, nMax;
	CString sValue;

	m_edContrast.GetWindowText(sValue);
	int nLength = sValue.GetLength();

	if (nLength == 0) {
		return;
	}				
	
	nValue = strtol	(sValue, (char **)&sValue, 10);
	if (nValue == m_Contrast.GetPos()) {
		return;	
	}

	m_Contrast.GetRange (nMin, nMax);
	nValue = min (max (nValue, nMin), nMax);

	SetItems( &m_Contrast, &m_edContrast, nValue);
	SetItems( &m_Contrast, &m_edContrast, m_Contrast.GetPos());
    pApp->m_Settings.HW_SetContrast (BW_ColorToHardware(m_Contrast.GetPos()));		

	SetModified( TRUE );
}

void CCaptureColor::OnUpdateEditContrast() 
{
}

//xxxxx this was added 
LRESULT CCaptureColor::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (message == WM_HELP)	{
		HELPINFO* pHelpInfo = (HELPINFO*) lParam;
		OnHelpInfo(pHelpInfo);
		return TRUE;
	} else if (message == WM_COMMAND)	{
		if (wParam == ID_HELP) {
			HELPINFO HelpInfo;

			HelpInfo.iContextType = HELPINFO_WINDOW;
			HelpInfo.iCtrlId = IDC_CAPTURE_OPTIONS;
			OnHelpInfo(&HelpInfo);
			return TRUE;
		}
	}

	return CDialog::WindowProc(message, wParam, lParam);
}


BOOL CCaptureColor::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if ( pHelpInfo->iContextType==HELPINFO_WINDOW )
	{
		long lParam = pHelpInfo->iCtrlId + HIDC_MYBASE;
    	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
    	CWnd* pMainWnd = this;

	    // return global app help mode state to FALSE (backward compatibility)
	    pApp->m_bHelpMode = FALSE;
	    pMainWnd->PostMessage(WM_KICKIDLE); // trigger idle update

	    pMainWnd->WinHelp(lParam, HELP_CONTEXT);
	}
	return TRUE;
}

LRESULT CCaptureColor::OnCommandHelp( WPARAM, LPARAM lParam )
{
    int nCtrlID = GetFocus()->GetDlgCtrlID(); // Get the ID of the control with the current focus

	lParam = nCtrlID + HIDC_MYBASE;
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
   	CWnd* pMainWnd = this;

    // return global app help mode state to FALSE (backward compatibility)
    pApp->m_bHelpMode = FALSE;
    pMainWnd->PostMessage(WM_KICKIDLE); // trigger idle update

    pMainWnd->WinHelp(lParam, HELP_CONTEXT);

    return TRUE;
}


