// CapAppearance.cpp : implementation file
//

#include "stdafx.h"
#include "bwdlgs.h"
#include "bwdialog.h"
#include "bwuser.h"
#include "CapAppearance.h"


#include "afxpriv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////////////
// CCaptureAudio property page

IMPLEMENT_DYNCREATE(CCapAppearance, CPropertyPage)

void CCapAppearance::SetModified(BOOL bChanged)
{
	m_bChanged = bChanged;
	CPropertyPage::SetModified( bChanged );
}

CCapAppearance::CCapAppearance() : CPropertyPage(CCapAppearance::IDD)
{
	//{{AFX_DATA_INIT(CCaptureAudio)
	//}}AFX_DATA_INIT
	m_psp.dwFlags |= PSP_HASHELP;
	m_bChanged = FALSE;
}

CCapAppearance::~CCapAppearance()
{
}

void CCapAppearance::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCapAppearance)
	DDX_Control(pDX, IDC_APPEARANCE_BLANKLINES_SPIN, m_BlanklinesSpin);
	DDX_Control(pDX, IDC_APPEARANCE_BLANKLINES, m_Blanklines);
	DDX_Control(pDX, IDC_COLOR_SOFTENING, m_EnableSoftening);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCapAppearance, CPropertyPage)
	//{{AFX_MSG_MAP(CCapAppearance)
	ON_EN_KILLFOCUS(IDC_APPEARANCE_BLANKLINES, OnKillfocusAppearanceBlanklines)
	ON_BN_CLICKED(IDC_APPEARANCE_DEFAULTS, OnAppearanceDefaults)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_COLOR_SOFTENING, OnColorSoftening)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CCapAppearance message handlers
BOOL CCapAppearance::OnInitDialog() 
{
	int BlankLines,lower,upper;
	char buffer[120];

	int FilterValue;

	CPropertyPage::OnInitDialog();

   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	// Set the Filter check
	FilterValue = pApp->m_Settings.FilterValue();
	m_EnableSoftening.SetCheck (FilterValue == 0 ?1:0); 

	
	// get the BlankLines and set within range
	BlankLines = pApp->m_Settings.BlankLines();
	m_BlanklinesSpin.SetRange(0,10);
    m_BlanklinesSpin.GetRange(lower,upper);

	if (BlankLines < lower)
			BlankLines = lower;
	if (BlankLines > upper)
		BlankLines = upper;

	// Reformat the data entry
	sprintf(buffer,"%3d",BlankLines);
	m_Blanklines.SetWindowText(buffer);

	// Update the spin control
	m_BlanklinesSpin.SetPos(BlankLines);

	// Change the property
	pApp->m_Settings.SetBlankLines( BlankLines );

	// TODO: Add extra initialization here
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCapAppearance::OnKillfocusAppearanceBlanklines() 
{
	
	int BlankLines,lower,upper;
	char buffer[120];

	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	// fetch the setting and convert to an integer
	m_Blanklines.GetLine(0,buffer,sizeof(buffer));
	BlankLines = atoi(buffer);

	if (BlankLines != m_BlanklinesSpin.GetPos ())	 {
		SetModified( TRUE );
	}

	// Check the bounds
	m_BlanklinesSpin.GetRange(lower,upper);
	if (BlankLines < lower)
		BlankLines = lower;
	if (BlankLines > upper)
		BlankLines = upper;

	// Reformat the data entry
	sprintf(buffer,"%3d",BlankLines);
	m_Blanklines.SetWindowText(buffer);

	// Update the spin control
	m_BlanklinesSpin.SetPos(BlankLines);

	// Change the property
	pApp->m_Settings.HW_SetBlankLines( BlankLines );
}



void CCapAppearance::OnAppearanceDefaults() 
{
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	UINT FilterValue = m_EnableSoftening.GetCheck() == 0 ?1:0;
	UINT BlankLines = m_BlanklinesSpin.GetPos();

	UINT defFilterValue	= pApp->m_Settings.DefaultFilterValue();
	UINT defBlankLines = pApp->m_Settings.DefaultBlankLines();

	if (FilterValue == defFilterValue && BlankLines == defBlankLines) {
		return;	
	}


	// default the softening filter
	m_EnableSoftening.SetCheck(defFilterValue == 0 ?1:0);
	pApp->m_Settings.HW_SetFilter(defFilterValue);

	// default the blanklines
	char buffer[120];

	sprintf(buffer,"%3d",defBlankLines);
	m_Blanklines.SetWindowText(buffer);

	m_BlanklinesSpin.SetPos(defBlankLines);
	pApp->m_Settings.HW_SetBlankLines( defBlankLines );

	// Force the screen to change
	//RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN);

	SetModified( TRUE );	
}



//xxxxx this was added 
LRESULT CCapAppearance::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (message == WM_HELP)	{
		HELPINFO* pHelpInfo = (HELPINFO*) lParam;
		OnHelpInfo(pHelpInfo);
		return TRUE;
	} else if (message == WM_COMMAND)	{
		if (wParam == ID_HELP) {
			HELPINFO HelpInfo;

			HelpInfo.iContextType = HELPINFO_WINDOW;
			HelpInfo.iCtrlId = IDC_CAPTURE_OPTIONS;
			OnHelpInfo(&HelpInfo);
			return TRUE;
		}
	} 

	return CDialog::WindowProc(message, wParam, lParam);
}


BOOL CCapAppearance::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if ( pHelpInfo->iContextType==HELPINFO_WINDOW )
	{
		long lParam = pHelpInfo->iCtrlId + HIDC_MYBASE;
    	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
    	CWnd* pMainWnd = this;

	    // return global app help mode state to FALSE (backward compatibility)
	    pApp->m_bHelpMode = FALSE;
	    pMainWnd->PostMessage(WM_KICKIDLE); // trigger idle update

	    pMainWnd->WinHelp(lParam, HELP_CONTEXT);
	}
	return TRUE;
}

LRESULT CCapAppearance::OnCommandHelp( WPARAM, LPARAM lParam )
{
    int nCtrlID = GetFocus()->GetDlgCtrlID(); // Get the ID of the control with the current focus

	lParam = nCtrlID + HIDC_MYBASE;
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
   	CWnd* pMainWnd = this;

    // return global app help mode state to FALSE (backward compatibility)
    pApp->m_bHelpMode = FALSE;
    pMainWnd->PostMessage(WM_KICKIDLE); // trigger idle update

    pMainWnd->WinHelp(lParam, HELP_CONTEXT);

    return TRUE;
}



void CCapAppearance::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	int BlankLines;
	char buffer[20];

	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	// fetch the setting and update the data entry
	BlankLines = m_BlanklinesSpin.GetPos();
	sprintf(buffer,"%3d",BlankLines);
	m_Blanklines.SetWindowText(buffer);
	m_Blanklines.UpdateWindow();

	pApp->m_Settings.HW_SetBlankLines( BlankLines );
	
	SetModified( TRUE );
	CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CCapAppearance::OnOK() 
{
	// TODO: Add your specialized code here and/or call the base class
	 CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	 if (m_bChanged) {
		pApp->m_Settings.SetFilterValue(m_nFilterValue);
		pApp->m_Settings.SetBlankLines(m_nBlankLines);
		SetModified (FALSE);
	 }

	
	CPropertyPage::OnOK();
}

BOOL CCapAppearance::OnKillActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	m_nFilterValue = m_EnableSoftening.GetCheck() == 0 ?1:0;
	m_nBlankLines = m_BlanklinesSpin.GetPos();
	
	return CPropertyPage::OnKillActive();
}

void CCapAppearance::OnColorSoftening() 
{
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	UINT FilterValue = m_EnableSoftening.GetCheck() == 0 ?1:0;
	
	pApp->m_Settings.HW_SetFilter(FilterValue);
	SetModified( TRUE );
}
