// progress.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "compress.h"
#include "bwdialog.h"

#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define ID_CONVERT_TIMER 989
#define WEIGHT_PER_SECOND 0.98

CModelessDialog::CModelessDialog(CModelessDialog** ppSelf)
{
	//m_ppSelf = ppSelf;
}
CModelessDialog::~CModelessDialog()
{
	//ASSERT(m_ppSelf==NULL || *m_ppSelf == this);
	//*m_ppSelf = NULL;
}

//Delete self agter window has been destroyed, to avoid TRACE
//message in CWnd.  This assumes dialog object is created in the heap
//not on the stack!!

void CModelessDialog::PostNcDestroy()
{
	delete this;
}

//Must override MFC implementation of CDialog::OnOk and OnCancel,
//which call EndDialog, which is for modal dialogs only.
//For modeless dialogs, must call DestroyWindow instead.

void CModelessDialog::OnOK()
{
	if (!UpdateData(TRUE)) { //Do Data Exchange
		TRACE0("UpdateData failed during dialog termination\n");
		//the UpdateData routine will set focus to the correct item
		return;
	}
	DestroyWindow();
}

void CModelessDialog::OnCancel()
{
	DestroyWindow();  //without updatedata
}


/////////////////////////////////////////////////////////////////////////////
// CCompressProgress dialog
//#define ID_PROGRESSTIMER 2


CCompressProgress::CCompressProgress(CWnd* pParent /*=NULL*/, CCompressProgress** ppSelf /*=NULL*/,
                 LPCTSTR lpstrFile/*=NULL*/, DWORD TotalCounts/*=2500*/,
                 BOOL ShowTimeRemaining/*=FALSE*/,  double InitialTimePerCount /*=0.0*/)
	: CModelessDialog((CModelessDialog **)ppSelf)
//	: CDialog(CCompressProgress::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCompressProgress)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pParent = pParent;
	m_sFileName.Empty();
	if (lpstrFile != NULL)
		m_sFileName = lpstrFile;

	m_nConvertTimer = 0;

	m_TotalCounts = TotalCounts;
    m_LastTime = 0;
    m_LastCount = 0;
    m_ShowTimeRemaining = ShowTimeRemaining;
    m_TimePerCount = InitialTimePerCount;
}

CCompressProgress::~CCompressProgress()
{
}

void CCompressProgress::DoDataExchange(CDataExchange* pDX)
{
	CModelessDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompressProgress)
	DDX_Control(pDX, IDC_TIME_LABEL, m_TimeLabel);
	DDX_Control(pDX, IDC_TIME_REMAINING, m_TimeRemaining);
	DDX_Control(pDX, IDC_TIME_REMAINING_LABEL, m_TimeRemainingLabel);
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_FILE_NAME, m_FileName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompressProgress, CModelessDialog)
	//{{AFX_MSG_MAP(CCompressProgress)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


	//ON_WM_TIMER()

/////////////////////////////////////////////////////////////////////////////
// CCompressProgress message handlers

BOOL CCompressProgress::OnInitDialog() 
{
	CModelessDialog::OnInitDialog();

#if 0
	m_nConvertTimer = SetTimer(
	    ID_CONVERT_TIMER,        	/* timer identifier     */
	    1000,                /*     				  	*/
	    NULL);  /* no timer callback    */
#endif

	m_Continue = TRUE;

	//FileName.SetWindowText( m_sFileName );
	m_Progress.SetRange(0, m_TotalCounts);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CCompressProgress::PreTranslateMessage(MSG* pMsg) 
{
	BOOL bRet = CModelessDialog::PreTranslateMessage(pMsg);
	//BOOL bResult = 0;

	return bRet;
}

void CCompressProgress::SetPercentage( UINT nPercent ) 
{
	//update progress bar
	m_Progress.SetPos( nPercent );

    //exit if time update is disabled
    if (!m_ShowTimeRemaining)
        return;

    //if first update, save current time and progress, then exit
    if (m_LastTime == 0) {
        //it this is the 1st update, init start time
        m_LastTime = timeGetTime();
        m_LastCount = nPercent;
        return;
    }


    //compute time remaining
    DWORD progress = nPercent - m_LastCount;
    if (progress == 0)
        return; //no progress, exit and avoid divide by zero

    //update est of time per count
    DWORD CurTime = timeGetTime();  //time in milliseconds
    double TimeDiff = ( CurTime - m_LastTime)/1000.0; //time in seconds
    double CurTimePerCount = TimeDiff / progress;
    if (m_TimePerCount == 0.0)
        m_TimePerCount = CurTimePerCount;
    else {
        double weight = pow(WEIGHT_PER_SECOND, TimeDiff); 
        m_TimePerCount = (1.0 - weight) * CurTimePerCount + weight * m_TimePerCount;
    }
    
    //save current time and count
    m_LastCount = nPercent;
    m_LastTime = CurTime;
     
    //compute time remaining = ticks remaining * time per tick
    DWORD TimeRemaining = (DWORD)((m_TotalCounts - nPercent) * m_TimePerCount);

    //format text and update dialog with time remaining
    char text[80];
    if (TimeRemaining < 60) {
        wsprintf(text, "%d", TimeRemaining);
        m_TextString.LoadString(IDS_SEC_LABEL);
    }
    else {
        wsprintf(text, "%d:%02d", TimeRemaining/60, TimeRemaining - 60*(TimeRemaining/60));
        m_TextString.LoadString(IDS_MIN_SEC_LABEL);
    }
    m_TimeRemainingLabel.ShowWindow(SW_SHOW);
    m_TimeRemaining.SetWindowText(text);
    m_TimeLabel.SetWindowText(m_TextString);

}

void CCompressProgress::OnCancel() 
{
	m_Continue = FALSE;
}

void CCompressProgress::OnDestroy() 
{
	CModelessDialog::OnDestroy();
}


LRESULT CCompressProgress::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
		
	return CModelessDialog::WindowProc(message, wParam, lParam);
}


void CCompressProgress::OnTimer(UINT nIDEvent) 
{
	CModelessDialog::OnTimer(nIDEvent);
}
