// encdlg+.h : header file
//

#include "paredit.h"


/////////////////////////////////////////////////////////////////////////////
// CEncodeDialog dialog

class CEncodeDialog : public CDialog
{
	
// Construction
public:
	void UpdateSizeDisplay();
	void RangeAudioSlider();
	void RangeQualitySlider();

    // Set the Dialog target to a capture target
	void SetCaptureTarget(BOOL bCapture) { m_Capture = bCapture;};

	CEncodeDialog(CWnd *pParent=NULL);

	BOOL m_bChanged;

	CString m_EncodeType;

	BOOL m_Capture; // Dialog box is launched from captute
	
	int m_MaxVideoRate;
	int m_MinVideoRate;

	int m_MaxAudioRate;
	int m_MinAudioRate;

	UINT m_DefaultAudioType;
	BOOL m_Mono;
	BOOL m_AudioTypeFixed;
	BOOL m_MonoAudioEnabled;
	BOOL m_StereoAudioEnabled;
	
	BOOL m_DisableAudioOnly;
	BOOL m_DisableVideoOnly;

	BOOL m_DisableSquarePixels;

	UINT m_StreamMixType;
	BOOL m_StreamMax;
	BOOL m_StreamFixed;
	CString m_iniFile;

    CString m_Target;
	UINT m_VideoEnable;
	UINT m_SquarePixels;
	UINT m_VideoRate;
	UINT m_AudioEnable;
	UINT m_AudioMode;
	UINT m_AudioRate;
    UINT m_CompressionEstimate;
	UINT m_OptimumRate;
    UINT m_StreamDataRate;
    UINT m_StreamPackSize;
    UINT m_PacketsPerPack;
	UINT m_nLargeImage;

	CParsedEdit edit1;
	CParsedEdit edit2;

// Dialog Data
	//{{AFX_DATA(CEncodeDialog)
	enum { IDD = IDD_COMPRESS_ENCODE_DLG };
	CComboBox	m_RealPlayBackTarget;
	CStatic	m_QualityText;
	CEdit	m_StreamRate;
	CStatic	m_StaImageSize;
	CButton	m_Sif;
	CStatic	m_StaSquare;
	CButton	m_Square;
	CStatic	m_StaMbm2;
	CStatic	m_StaMbm;
	CStatic	m_StaChan;
	CStatic	m_StaVideo;
	CButton	m_chkVideo;
	CComboBox	m_PlayBackTarget;
	CStatic	m_StaRangeLow2;
	CStatic	m_StaRangeLow;
	CStatic	m_StaRangeHigh2;
	CStatic	m_StaRangeHigh;
	CStatic	m_StaMiddle2;
	CStatic	m_StaMiddle;
	CStatic	m_StaLow2;
	CStatic	m_StaLow;
	CStatic	m_StaHigher2;
	CStatic	m_StaHigher;
	CStatic	m_StaDataRate2;
	CStatic	m_StaDataRate;
	CStatic	m_StaAudio;
	CButton	m_chkAudio;
	CSliderCtrl	m_AudioQualitySlider;
	CButton	m_Defaults;
	CEdit	m_edDiskSpace;
	CSliderCtrl	m_QualitySlider;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEncodeDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation

	
	BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	UINT GetAudioMode();
	UINT GetAudioRate();
	UINT GetAudioEnable();
	UINT GetVideoEnable();
	void EnableAudio( BOOL bEnable );
	void EnableVideo( BOOL bEnable );
	UINT SetAudioMode( UINT nAudioMode );
	UINT SetAudioRate ( UINT nAudioRate );
	void SetModified( BOOL bModified );

protected:
	void SetAudioPos(int pos);
	int GetAudioPos();
	void QualitySetPos(int pos);
	int QualityGetPos();
	void UpdateTargetSpecs();
	int CalcQualityPos(int pos);
	int CalcAudioPos(int pos);
	void CEncodeDialog::SetSquarePixels( BOOL nSquarePixels );
	BOOL CEncodeDialog::GetSquarePixels(); 
	virtual BOOL OnKillActive( );
	virtual void OnCancel();
	virtual void OnOK();

	// Generated message map functions
	//{{AFX_MSG(CEncodeDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnDefaults();
	afx_msg void OnSquarechk();
	afx_msg void OnAudiochk();
	afx_msg void OnVideochk();
	afx_msg void OnRbmono();
	afx_msg void OnRbjointstereo();
	afx_msg void OnRbdualchannel();
	afx_msg void OnRbstereo();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSelchangePlaybackTarget();
	afx_msg void OnSelendokPlaybackTarget();
	afx_msg void OnSif();
	afx_msg void OnSquare();
	afx_msg void OnKillfocusVideoEdit();
	afx_msg void OnKillfocusAudioEdit();
	//}}AFX_MSG
    afx_msg LRESULT OnCommandHelp( WPARAM, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
private:
	void UpdateAudioRates();
};


