// captaud.h : header file
//

#ifndef _CAPTURE_AUDIO_H
#define _CAPTURE_AUDIO_H

#include "mark.h"				     
#include "AudioLevel.h"
#include "VolumeHelp.h"

/////////////////////////////////////////////////////////////////////////////
// CCaptureAudio dialog

class CCaptureAudio : public CPropertyPage
{
	DECLARE_DYNCREATE(CCaptureAudio)

// Construction
public:
	CCaptureAudio();
	~CCaptureAudio();

	BOOL m_bChanged;
	BOOL m_bIsRecording;
	BOOL m_HelpDisplayed;

// Dialog Data
	//{{AFX_DATA(CCaptureAudio)
	enum { IDD = IDD_CAPTURE_AUDIO };
	CButton	m_chkShowHelp;
	CButton	m_Mixer;
	CMark	m_Power;
	CSliderCtrl	m_Volume;
	CButton	m_EnableAudio;
	CButton	m_Defaults;
	//}}AFX_DATA

	UINT m_nAudioEnable;
	UINT m_nAudioMode;
	UINT m_nAudioRate;
	UINT m_nShowHelp;

	BOOL m_nIsMpeg;

	HWAVEIN m_hWave;
    WAVEFORMATEX m_Format;
    WAVEHDR *m_waveHdr;
	DWORD m_Range;

	CAudioLevel AudioLevel;

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCaptureAudio)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
	void SetModified(BOOL bChanged = TRUE);
	void SetAudioEnable( BOOL bEnable );
	void SetAudioRate(UINT nAudioRate);
	UINT GetAudioEnable();
	UINT GetAudioMode();
	void SetAudioMode( UINT nAudioMode );
	virtual void OnOK( );
	virtual BOOL OnKillActive( );
	UINT GetAudioRate();
	BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	
	BOOL BeginRecording ();
	BOOL EndRecording ();

	void UpdateTargetSpecs();

	static const unsigned int	m_kNUM_HEADERS;
	static const unsigned int	m_kTimerPEAK;
	static const unsigned int	m_kTimerVOLUME;
	static const unsigned int	m_kTimerPEAKINTERVAL;
	static const unsigned int	m_kTimerVOLUMEINTERVAL;

protected:

	// Generated message map functions
	//{{AFX_MSG(CCaptureAudio)
	virtual BOOL OnInitDialog();
	afx_msg void OnDefaults();
	afx_msg void On11khz();
	afx_msg void On22khz();
	afx_msg void On44khz();
	afx_msg void OnMono();
	afx_msg void OnStereo();
	afx_msg void OnAudioEnable();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnMixer();
	afx_msg void OnShowhelp();
	//}}AFX_MSG
    afx_msg LRESULT OnCommandHelp( WPARAM, LPARAM lParam );
	DECLARE_MESSAGE_MAP()

};

#endif
