// captqual.cpp : implementation file
//

#include "stdafx.h"
#include "bwdialog.h"
#include "captqual.h"

#include "afxpriv.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCaptureQuality dialog

IMPLEMENT_DYNCREATE(CCaptureQuality, CPropertyPage)

void CCaptureQuality::SetModified(BOOL bChanged)
{
	m_bChanged = bChanged;
	CPropertyPage::SetModified( bChanged );
}

CCaptureQuality::CCaptureQuality() : CPropertyPage(CCaptureQuality::IDD)
{
	//{{AFX_DATA_INIT(CCaptureQuality)
	//}}AFX_DATA_INIT
	m_psp.dwFlags |= PSP_HASHELP;
	m_bChanged = FALSE;
}

CCaptureQuality::~CCaptureQuality()
{
}

void CCaptureQuality::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureQuality)
	DDX_Control(pDX, IDC_QUALITY_VIDEO_QUALITY_EDIT, m_edQuality);
	DDX_Control(pDX, IDC_QUALITY_VIDEO_QUALITY, m_RateSlider);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCaptureQuality, CPropertyPage)
	//{{AFX_MSG_MAP(CCaptureQuality)
	ON_BN_CLICKED(IDC_QUALITY_DEFAULTS, OnDefaults)
	ON_WM_VSCROLL()
	ON_EN_KILLFOCUS(IDC_QUALITY_VIDEO_QUALITY_EDIT, OnKillfocusVideoQualityEdit)
	ON_EN_UPDATE(IDC_QUALITY_VIDEO_QUALITY_EDIT, OnUpdateVideoQualityEdit)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
    ON_MESSAGE( WM_COMMANDHELP, OnCommandHelp )
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CCaptureQuality message handlers
BOOL CCaptureQuality::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	// enable help button 
	CWnd* pHelpButton = GetDlgItem(ID_HELP);
	if (pHelpButton != NULL) {
		pHelpButton->ShowWindow(SW_SHOW);
	}

	m_nLowRange  = 35;
	m_nHighRange = 75;

	m_RateSlider.SetRange(m_nLowRange,m_nHighRange,TRUE);
	m_RateSlider.SetFocus();

    m_RateSlider.SetTicFreq(10);

    m_edQuality.SetLimitText(2);

	// TODO: Add extra initialization here
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	
	UINT nBitRate = pApp->m_Settings.BitRate();

	SetItems( &m_RateSlider, &m_edQuality, nBitRate );
	m_RateSlider.SetPos( nBitRate );
    m_nRate = nBitRate;

	return FALSE;	
	//return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CCaptureQuality::OnDefaults() 
{
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	if (pApp->m_Settings.DefaultBitRate() != (UINT)m_RateSlider.GetPos()) {
    	
		UINT nBitRate = pApp->m_Settings.DefaultBitRate();

	    SetItems( &m_RateSlider, &m_edQuality, nBitRate );
	    m_RateSlider.SetPos( nBitRate );

		SetModified( TRUE );
	}
}


void CCaptureQuality::SetItems( CSliderCtrl *pSlider, CEdit *pEdit, int nValue )
{
	char szText[30];

	itoa( nValue, szText, 10 );
	pEdit->SetWindowText( szText );
}

BOOL CCaptureQuality::OnKillActive( )
{
	UINT nPos = m_RateSlider.GetPos();
	m_nRate = nPos;

	return( TRUE );
}

void CCaptureQuality::OnOK( )
{
	if (m_bChanged)
	{
		CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

		pApp->m_Settings.SetBitRate( m_nRate );

		SetModified( FALSE );
	}
	CPropertyPage::OnOK();
}

void CCaptureQuality::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	    //handle scroll message based on source window
    HWND sourceWnd = pScrollBar->GetSafeHwnd();
    if (sourceWnd == NULL) {
        //default processing if no source
		CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
    }
	else if (sourceWnd == m_RateSlider.GetSafeHwnd()) {
		SetModified( TRUE );
		SetItems( &m_RateSlider, &m_edQuality, m_RateSlider.GetPos() );
	}
    else {
        //default processing if some other source
		CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
    }
}

void CCaptureQuality::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	    //handle scroll message based on source window
    HWND sourceWnd = pScrollBar->GetSafeHwnd();
    if (sourceWnd == NULL) {
        //default processing if no source
		CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
    }
	else if (sourceWnd == m_RateSlider.GetSafeHwnd()) {
		SetModified( TRUE );
		SetItems( &m_RateSlider, &m_edQuality, m_RateSlider.GetPos() );
	}
    else {
        //default processing if some other source
		CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
    }
}


//xxxxx this was added 
LRESULT CCaptureQuality::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (message == WM_HELP)	{
		HELPINFO* pHelpInfo = (HELPINFO*) lParam;
		OnHelpInfo(pHelpInfo);
		return TRUE;
	} else if (message == WM_COMMAND)	{
		if (wParam == ID_HELP) {
			HELPINFO HelpInfo;

			HelpInfo.iContextType = HELPINFO_WINDOW;
			HelpInfo.iCtrlId = IDC_CAPTURE_OPTIONS;
			OnHelpInfo(&HelpInfo);
			return TRUE;
		}
	}

	return CPropertyPage::WindowProc(message, wParam, lParam);
}

BOOL CCaptureQuality::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if ( pHelpInfo->iContextType==HELPINFO_WINDOW )
	{
		long lParam = pHelpInfo->iCtrlId + HIDC_MYBASE;
    	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
    	CWnd* pMainWnd = this;

	    // return global app help mode state to FALSE (backward compatibility)
	    pApp->m_bHelpMode = FALSE;
	    pMainWnd->PostMessage(WM_KICKIDLE); // trigger idle update

	    pMainWnd->WinHelp(lParam, HELP_CONTEXT);
	}
	return TRUE;
}

LRESULT CCaptureQuality::OnCommandHelp( WPARAM, LPARAM lParam )
{
    int nCtrlID = GetFocus()->GetDlgCtrlID(); // Get the ID of the control with the current focus

	lParam = nCtrlID + HIDC_MYBASE;
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
   	CWnd* pMainWnd = this;

    // return global app help mode state to FALSE (backward compatibility)
    pApp->m_bHelpMode = FALSE;
    pMainWnd->PostMessage(WM_KICKIDLE); // trigger idle update

    pMainWnd->WinHelp(lParam, HELP_CONTEXT);

    return TRUE;
}

void CCaptureQuality::OnKillfocusVideoQualityEdit() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	int nValue, nMin, nMax;
	CString sValue;

	m_edQuality.GetWindowText(sValue);
	int nLength = sValue.GetLength();

	if (nLength == 0) {
		return;
	}									 

	nValue = strtol	(sValue, (char **)&sValue, 10);

	if (nValue == m_RateSlider.GetPos()) {
		return;	
	}

	m_RateSlider.GetRange (nMin, nMax);
	nValue = min (max (nValue, nMin), nMax);

	m_RateSlider.SetPos (nValue);
	SetItems( &m_RateSlider, &m_edQuality, nValue);

	SetModified( TRUE );
}

void CCaptureQuality::OnUpdateVideoQualityEdit() 
{
}


