#ifndef __VT_RECODE_ERRORS__
#define __VT_RECODE_ERRORS__
/* errors.h
This file defines the errors for the video tool re-coder program
*/

void ProcessError(int ErrorNum);

#define ERROR_FILE_WRITE            1
#define ERROR_PACK_SIZE_TOO_SMALL   2
#define ERROR_PACKET_SIZE_TOO_SMALL 3
#define ERROR_RATE_TOO_SLOW         4
#define ERROR_STARTUP_ALLOCATION    5
#define ERROR_MEMORY_ALLOCATION     6
#define ERROR_INVALID_AUDIO_DATA    7
#define ERROR_FREE_AUDIO_RATE_NOT_SUPPORTED 8
#define ERROR_LAYER_3_NOT_SUPPORTED 9

#define RECODE_BASE_ERROR 100

#define VT_ERR_CANT_OPEN_OUTPUT_FILE     (RECODE_BASE_ERROR + 0)
#define VT_ERR_CANT_OPEN_VIDEO_STREAM    (RECODE_BASE_ERROR + 1)
#define VT_ERR_BAD_INPUT_VIDEO_TYPE      (RECODE_BASE_ERROR + 2)
#define VT_ERR_NO_DMA_FRAME              (RECODE_BASE_ERROR + 3)
#define VT_ERR_NOT_PCI_MACHINE           (RECODE_BASE_ERROR + 4)
#define VT_ERR_HARDWARE_NOT_FOUND        (RECODE_BASE_ERROR + 5)
#define VT_ERR_CANT_OPEN_AVI_FILE        (RECODE_BASE_ERROR + 6)
#define VT_ERR_CANT_CREATE_AUDIO_THREAD  (RECODE_BASE_ERROR + 7)
#define VT_ERR_CANT_OPEN_AUDIO_STREAM    (RECODE_BASE_ERROR + 8)
#define VT_ERR_NOT_44100_KHZ_AUDIO       (RECODE_BASE_ERROR + 9)
#define VT_ERR_NOT_16BIT_AUDIO           (RECODE_BASE_ERROR + 10)
#define VT_ERR_TOO_MANY_AUDIO_CHANNELS   (RECODE_BASE_ERROR + 11)
#define VT_ERR_NO_AUDIO_CHANNELS         (RECODE_BASE_ERROR + 12)
#define VT_ERR_CANT_ALLOC_AUDIO_ENCODER  (RECODE_BASE_ERROR + 13)
#define VT_ERR_NOT_PCM_AUDIO             (RECODE_BASE_ERROR + 14)
#define VT_ERR_MEMORY_ERROR              (RECODE_BASE_ERROR + 15)
#define VT_ERR_CANT_CREATE_STREAM_THREAD (RECODE_BASE_ERROR + 16)
#define VT_ERR_CANT_OPEN_VIDEO_MPG_FILE  (RECODE_BASE_ERROR + 17)
#define VT_ERR_CANT_OPEN_AUDIO_MPG_FILE  (RECODE_BASE_ERROR + 18)

#endif //#ifndef __VT_RECODE_ERRORS__


