/*
 * videobuf.h
 *
 * 32-bit Video Capture driver
 * Video buffer data structures and definitions for Video Tool
 *
 * Mark Vrabel, October 1995
 */

#ifndef _VIDEOBUF_H_
#define _VIDEOBUF_H_


#define MAX_VIDEO_BUFS 10


#pragma pack(1) 

/* 
 * Video buffer information structure
 */
typedef struct _VIDEO_BUFFER {

    DWORD FAR *lpData;     // linear address of buffer memory
    DWORD dwStartIndex;    // index of actual frame start
	DWORD dwPhys;          // physical address of buffer memory
    DWORD dwLength;        // Size of buffer memory in dwords  
	DWORD dwFilled;        // number of dwords filled  
    DWORD dwTimeStamp;     // time tamp of buffer when filled
	DWORD dwReserved[4];   // reserved for future use
} VIDEO_BUFFER, *PVIDEO_BUFFER, FAR *LPVIDEO_BUFFER;


/* 
 * Video buffer list structure
 */
typedef struct _VIDEO_BUFFER_LIST {

    DWORD dwNumberBufs;             // actual buffer count
    DWORD dwDmaIndex;               // dma buffer index
    DWORD dwCurrentBuf;             // current buffer index
   
    VIDEO_BUFFER Bufs[MAX_VIDEO_BUFS]; // video buffers

} VIDEO_BUFFER_LIST, *PVIDEO_BUFFER_LIST, FAR *LPVIDEO_BUFFER_LIST;

#pragma pack()

#endif // _VIDEOBUF_H_
