/*
 * voverlay.h
 *
 * 32-bit Video Capture driver
 * virtual overlay data structures and definitions for Video Tool
 *
 * Mark Vrabel, October 1995
 */

#ifndef _VOVERLAY_H_
#define _VOVERLAY_H_

#define VOVERLAY_HANDLE  DWORD

#ifdef __cplusplus
extern "C" {
#endif

BOOL WINAPI VO_InitializeOverlay (VIDEO_BUFFER_LIST FAR *lpBufList, VOVERLAY_HANDLE FAR *lpvoh);
BOOL WINAPI VO_TerminateOverlay (VOVERLAY_HANDLE voh);
BOOL WINAPI VO_SetOverlaySourceFormat (VOVERLAY_HANDLE voh, LONG Width, LONG Height,
									   LONG BlankLines);
BOOL WINAPI 
VO_SetOverlayBlankLines (VOVERLAY_HANDLE voh,LONG BlankLines);

BOOL WINAPI VO_SetOverlayDestFormat (VOVERLAY_HANDLE voh, LONG Width, LONG Height);
BOOL WINAPI VO_SetOverlayParentWindow(VOVERLAY_HANDLE voh, HWND hWnd);
BOOL WINAPI VO_StartOverlay (VOVERLAY_HANDLE voh);
BOOL WINAPI VO_StopOverlay(VOVERLAY_HANDLE voh);
BOOL WINAPI VO_PauseOverlay(VOVERLAY_HANDLE voh);
BOOL WINAPI VO_ContinueOverlay(VOVERLAY_HANDLE voh);
BOOL WINAPI VO_DrawFrame(VOVERLAY_HANDLE voh);
BOOL WINAPI VO_NotifyStreamStart (VOVERLAY_HANDLE voh, BOOL bStart);
BOOL WINAPI VO_DrawFrameNow (VOVERLAY_HANDLE voh);

#ifdef __cplusplus
}
#endif

 
#endif // _VOVERLAY_H_



