/*
 * realtime.h
 *
 *
 * 32-bit Video Tool driver
 * realtime mpeg capture window subclass 
 * routines for Data Translation Video Tool.
 *
 * Mark Vrabel, October 96
 */

#ifndef _REALTIME_H_
#define _REALTIME_H_

/*
 * capture hardware handle. This structure is opaque to the caller
 */
typedef struct _HWINFO FAR * LPHWINFO;



#if 0

/* 
 * these are straight form vfw.h - I just keep 'em around so I don't 
 * have to keep looking them up.
 */

#define IDS_CAP_BEGIN               300  /* "Capture Start" */
#define IDS_CAP_END                 301  /* "Capture End" */

#define IDS_CAP_INFO                401  /* "%s" */
#define IDS_CAP_OUTOFMEM            402  /* "Out of memory" */
#define IDS_CAP_FILEEXISTS          403  /* "File '%s' exists -- overwrite it?" */
#define IDS_CAP_ERRORPALOPEN        404  /* "Error opening palette '%s'" */
#define IDS_CAP_ERRORPALSAVE        405  /* "Error saving palette '%s'" */
#define IDS_CAP_ERRORDIBSAVE        406  /* "Error saving frame '%s'" */
#define IDS_CAP_DEFAVIEXT           407  /* "avi" */
#define IDS_CAP_DEFPALEXT           408  /* "pal" */
#define IDS_CAP_CANTOPEN            409  /* "Cannot open '%s'" */
#define IDS_CAP_SEQ_MSGSTART        410  /* "Select OK to start capture\nof video sequence\nto %s." */
#define IDS_CAP_SEQ_MSGSTOP         411  /* "Hit ESCAPE or click to end capture" */

#define IDS_CAP_VIDEDITERR          412  /* "An error occurred while trying to run VidEdit." */
#define IDS_CAP_READONLYFILE        413  /* "The file '%s' is a read-only file." */
#define IDS_CAP_WRITEERROR          414  /* "Unable to write to file '%s'.\nDisk may be full." */
#define IDS_CAP_NODISKSPACE         415  /* "There is no space to create a capture file on the specified device." */
#define IDS_CAP_SETFILESIZE         416  /* "Set File Size" */
#define IDS_CAP_SAVEASPERCENT       417  /* "SaveAs: %2ld%%  Hit Escape to abort." */

#define IDS_CAP_DRIVER_ERROR        418  /* Driver specific error message */

#define IDS_CAP_WAVE_OPEN_ERROR     419  /* "Error: Cannot open the wave input device.\nCheck sample size, frequency, and channels." */
#define IDS_CAP_WAVE_ALLOC_ERROR    420  /* "Error: Out of memory for wave buffers." */
#define IDS_CAP_WAVE_PREPARE_ERROR  421  /* "Error: Cannot prepare wave buffers." */
#define IDS_CAP_WAVE_ADD_ERROR      422  /* "Error: Cannot add wave buffers." */
#define IDS_CAP_WAVE_SIZE_ERROR     423  /* "Error: Bad wave size." */

#define IDS_CAP_VIDEO_OPEN_ERROR    424  /* "Error: Cannot open the video input device." */
#define IDS_CAP_VIDEO_ALLOC_ERROR   425  /* "Error: Out of memory for video buffers." */
#define IDS_CAP_VIDEO_PREPARE_ERROR 426  /* "Error: Cannot prepare video buffers." */
#define IDS_CAP_VIDEO_ADD_ERROR     427  /* "Error: Cannot add video buffers." */
#define IDS_CAP_VIDEO_SIZE_ERROR    428  /* "Error: Bad video size." */

#define IDS_CAP_FILE_OPEN_ERROR     429  /* "Error: Cannot open capture file." */
#define IDS_CAP_FILE_WRITE_ERROR    430  /* "Error: Cannot write to capture file.  Disk may be full." */
#define IDS_CAP_RECORDING_ERROR     431  /* "Error: Cannot write to capture file.  Data rate too high or disk full." */
#define IDS_CAP_RECORDING_ERROR2    432  /* "Error while recording" */
#define IDS_CAP_AVI_INIT_ERROR      433  /* "Error: Unable to initialize for capture." */
#define IDS_CAP_NO_FRAME_CAP_ERROR  434  /* "Warning: No frames captured.\nConfirm that vertical sync interrupts\nare configured and enabled." */
#define IDS_CAP_NO_PALETTE_WARN     435  /* "Warning: Using default palette." */
#define IDS_CAP_MCI_CONTROL_ERROR   436  /* "Error: Unable to access MCI device." */
#define IDS_CAP_MCI_CANT_STEP_ERROR 437  /* "Error: Unable to step MCI device." */
#define IDS_CAP_NO_AUDIO_CAP_ERROR  438  /* "Error: No audio data captured.\nCheck audio card settings." */
#define IDS_CAP_AVI_DRAWDIB_ERROR   439  /* "Error: Unable to draw this data format." */
#define IDS_CAP_COMPRESSOR_ERROR    440  /* "Error: Unable to initialize compressor." */
#define IDS_CAP_AUDIO_DROP_ERROR    441  /* "Error: Audio data was lost during capture, reduce capture rate." */

/* status string IDs */
#define IDS_CAP_STAT_LIVE_MODE      500  /* "Live window" */
#define IDS_CAP_STAT_OVERLAY_MODE   501  /* "Overlay window" */
#define IDS_CAP_STAT_CAP_INIT       502  /* "Setting up for capture - Please wait" */
#define IDS_CAP_STAT_CAP_FINI       503  /* "Finished capture, now writing frame %ld" */
#define IDS_CAP_STAT_PALETTE_BUILD  504  /* "Building palette map" */
#define IDS_CAP_STAT_OPTPAL_BUILD   505  /* "Computing optimal palette" */
#define IDS_CAP_STAT_I_FRAMES       506  /* "%d frames" */
#define IDS_CAP_STAT_L_FRAMES       507  /* "%ld frames" */
#define IDS_CAP_STAT_CAP_L_FRAMES   508  /* "Captured %ld frames" */
#define IDS_CAP_STAT_CAP_AUDIO      509  /* "Capturing audio" */
#define IDS_CAP_STAT_VIDEOCURRENT   510  /* "Captured %ld frames (%ld dropped) %d.%03d sec." */
#define IDS_CAP_STAT_VIDEOAUDIO     511  /* "Captured %d.%03d sec.  %ld frames (%ld dropped) (%d.%03d fps).  %ld audio bytes (%d,%03d sps)" */
#define IDS_CAP_STAT_VIDEOONLY      512  /* "Captured %d.%03d sec.  %ld frames (%ld dropped) (%d.%03d fps)" */
#define IDS_CAP_STAT_FRAMESDROPPED  513  /* "Dropped %ld of %ld frames (%d.%02d%%) during capture." */

/* these are our one erros */
#define IDS_RT_FIRST_STRING				    2000	/* first non AVICAP string */
#define IDS_RT_WAVE_FORMAT_NOT_PCM_ERROR	2000	/* "Error: Audio format must be set to PCM for realtime capture." */
#define IDS_RT_WAVE_FORMAT_NOT_16BIT_ERROR	2001	/* "Error: Audio format must be set to 16 bit sample size for realtime capture." */
#define IDS_RT_VIDEO_DROP_ERROR				2002	/* "Error: video data was lost during capture, reduce capture rate." */
#define IDS_RT_STAT_AUDIOCURRENT			2003	/* "Captured %ld audio bytes %d.%03d sec." */
#define IDS_RT_STAT_AUDIOONLY				2004    /* "Captured %d.%03d sec. %ld audio bytes (%d,%03d sps)" */
#define IDS_RT_AUDIO_DROP_ERROR				2006	/* "Error: Audio data was lost during MPEG capture. To avoid this, reduce the audio format (in KHz) on the Audio Capture page in  Capture Options and/or reduce the video data rate on the Compression Options page in Capture Options." */
#define IDS_RT_CAPTURE_LIMIT_2GB			2006	/* "You have captured the maximum file size allowed (2GB).  Capture has stopped." */
#define IDS_RT_CAPTURE_LIMIT_4GB			2007    /* "You have captured the maximum file size allowed (4GB).  Capture has stopped." */


#endif


/* 
 * capture window message macros
 */

#define BWCapSM(hwnd,m,w,l) ( (IsWindow(hwnd)) ?   CallWindowProc(gfpOrigCapWndProc, hwnd, m, w, l) : 0)

#define bcapSetCallbackOnError(hwnd, fpProc)        ((BOOL)BWCapSM(hwnd, WM_CAP_SET_CALLBACK_ERROR, 0, (LPARAM)(LPVOID)(fpProc)))
#define bcapSetCallbackOnStatus(hwnd, fpProc)       ((BOOL)BWCapSM(hwnd, WM_CAP_SET_CALLBACK_STATUS, 0, (LPARAM)(LPVOID)(fpProc)))
#define bcapSetCallbackOnYield(hwnd, fpProc)        ((BOOL)BWCapSM(hwnd, WM_CAP_SET_CALLBACK_YIELD, 0, (LPARAM)(LPVOID)(fpProc)))
#define bcapSetCallbackOnFrame(hwnd, fpProc)        ((BOOL)BWCapSM(hwnd, WM_CAP_SET_CALLBACK_FRAME, 0, (LPARAM)(LPVOID)(fpProc)))
#define bcapSetCallbackOnVideoStream(hwnd, fpProc)  ((BOOL)BWCapSM(hwnd, WM_CAP_SET_CALLBACK_VIDEOSTREAM, 0, (LPARAM)(LPVOID)(fpProc)))
#define bcapSetCallbackOnWaveStream(hwnd, fpProc)   ((BOOL)BWCapSM(hwnd, WM_CAP_SET_CALLBACK_WAVESTREAM, 0, (LPARAM)(LPVOID)(fpProc)))
#define bcapSetCallbackOnCapControl(hwnd, fpProc)   ((BOOL)BWCapSM(hwnd, WM_CAP_SET_CALLBACK_CAPCONTROL, 0, (LPARAM)(LPVOID)(fpProc)))

#define bcapSetUserData(hwnd, lUser)				((BOOL)BWCapSM(hwnd, WM_CAP_SET_USER_DATA, 0, (LPARAM)lUser))
#define bcapGetUserData(hwnd)						(BWCapSM(hwnd, WM_CAP_GET_USER_DATA, 0, 0))

#define bcapDriverConnect(hwnd, i)                  ((BOOL)BWCapSM(hwnd, WM_CAP_DRIVER_CONNECT, (WPARAM)(i), 0L))
#define bcapDriverDisconnect(hwnd)                  ((BOOL)BWCapSM(hwnd, WM_CAP_DRIVER_DISCONNECT, (WPARAM)0, 0L))
#define bcapDriverGetName(hwnd, szName, wSize)      ((BOOL)BWCapSM(hwnd, WM_CAP_DRIVER_GET_NAME, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPTSTR)(szName)))
#define bcapDriverGetVersion(hwnd, szVer, wSize)    ((BOOL)BWCapSM(hwnd, WM_CAP_DRIVER_GET_VERSION, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPTSTR)(szVer)))
#define bcapDriverGetCaps(hwnd, s, wSize)           ((BOOL)BWCapSM(hwnd, WM_CAP_DRIVER_GET_CAPS, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPCAPDRIVERCAPS)(s)))

#define bcapFileSetCaptureFile(hwnd, szName)        ((BOOL)BWCapSM(hwnd, WM_CAP_FILE_SET_CAPTURE_FILE, 0, (LPARAM)(LPVOID)(LPTSTR)(szName)))
#define bcapFileGetCaptureFile(hwnd, szName, wSize) ((BOOL)BWCapSM(hwnd, WM_CAP_FILE_GET_CAPTURE_FILE, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPTSTR)(szName)))
#define bcapFileAlloc(hwnd, dwSize)                 ((BOOL)BWCapSM(hwnd, WM_CAP_FILE_ALLOCATE, 0, (LPARAM)(DWORD)(dwSize)))
#define bcapFileSaveAs(hwnd, szName)                ((BOOL)BWCapSM(hwnd, WM_CAP_FILE_SAVEAS, 0, (LPARAM)(LPVOID)(LPTSTR)(szName)))
#define bcapFileSetInfoChunk(hwnd, lpInfoChunk)     ((BOOL)BWCapSM(hwnd, WM_CAP_FILE_SET_INFOCHUNK, (WPARAM)0, (LPARAM)(LPCAPINFOCHUNK)(lpInfoChunk)))
#define bcapFileSaveDIB(hwnd, szName)               ((BOOL)BWCapSM(hwnd, WM_CAP_FILE_SAVEDIB, 0, (LPARAM)(LPVOID)(LPTSTR)(szName)))

#define bcapEditCopy(hwnd)                          ((BOOL)BWCapSM(hwnd, WM_CAP_EDIT_COPY, 0, 0L))

#define bcapSetAudioFormat(hwnd, s, wSize)          ((BOOL)BWCapSM(hwnd, WM_CAP_SET_AUDIOFORMAT, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPWAVEFORMATEX)(s)))
#define bcapGetAudioFormat(hwnd, s, wSize)          ((DWORD)BWCapSM(hwnd, WM_CAP_GET_AUDIOFORMAT, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPWAVEFORMATEX)(s)))
#define bcapGetAudioFormatSize(hwnd)                ((DWORD)BWCapSM(hwnd, WM_CAP_GET_AUDIOFORMAT, (WPARAM)0, (LPARAM)0L))

#define bcapDlgVideoFormat(hwnd)                    ((BOOL)BWCapSM(hwnd, WM_CAP_DLG_VIDEOFORMAT, 0, 0L))
#define bcapDlgVideoSource(hwnd)                    ((BOOL)BWCapSM(hwnd, WM_CAP_DLG_VIDEOSOURCE, 0, 0L))
#define bcapDlgVideoDisplay(hwnd)                   ((BOOL)BWCapSM(hwnd, WM_CAP_DLG_VIDEODISPLAY, 0, 0L))
#define bcapDlgVideoCompression(hwnd)               ((BOOL)BWCapSM(hwnd, WM_CAP_DLG_VIDEOCOMPRESSION, 0, 0L))

#define bcapGetVideoFormat(hwnd, s, wSize)          ((DWORD)BWCapSM(hwnd, WM_CAP_GET_VIDEOFORMAT, (WPARAM)(wSize), (LPARAM)(LPVOID)(s)))
#define bcapGetVideoFormatSize(hwnd)            ((DWORD)BWCapSM(hwnd, WM_CAP_GET_VIDEOFORMAT, 0, 0L))
#define bcapSetVideoFormat(hwnd, s, wSize)          ((BOOL)BWCapSM(hwnd, WM_CAP_SET_VIDEOFORMAT, (WPARAM)(wSize), (LPARAM)(LPVOID)(s)))

#define bcapPreview(hwnd, f)                        ((BOOL)BWCapSM(hwnd, WM_CAP_SET_PREVIEW, (WPARAM)(BOOL)(f), 0L))
#define bcapPreviewRate(hwnd, wMS)                  ((BOOL)BWCapSM(hwnd, WM_CAP_SET_PREVIEWRATE, (WPARAM)(wMS), 0))
#define bcapOverlay(hwnd, f)                        ((BOOL)BWCapSM(hwnd, WM_CAP_SET_OVERLAY, (WPARAM)(BOOL)(f), 0L))
#define bcapPreviewScale(hwnd, f)                   ((BOOL)BWCapSM(hwnd, WM_CAP_SET_SCALE, (WPARAM)(BOOL)f, 0L))
#define bcapGetStatus(hwnd, s, wSize)               ((BOOL)BWCapSM(hwnd, WM_CAP_GET_STATUS, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPCAPSTATUS)(s)))
#define bcapSetScrollPos(hwnd, lpP)                 ((BOOL)BWCapSM(hwnd, WM_CAP_SET_SCROLL, (WPARAM)0, (LPARAM)(LPPOINT)(lpP)))

#define bcapGrabFrame(hwnd)                         ((BOOL)BWCapSM(hwnd, WM_CAP_GRAB_FRAME, (WPARAM)0, (LPARAM)0L))
#define bcapGrabFrameNoStop(hwnd)                   ((BOOL)BWCapSM(hwnd, WM_CAP_GRAB_FRAME_NOSTOP, (WPARAM)0, (LPARAM)0L))

#define bcapCaptureSequence(hwnd)                   ((BOOL)BWCapSM(hwnd, WM_CAP_SEQUENCE, (WPARAM)0, (LPARAM)0L))
#define bcapCaptureSequenceNoFile(hwnd)             ((BOOL)BWCapSM(hwnd, WM_CAP_SEQUENCE_NOFILE, (WPARAM)0, (LPARAM)0L))
#define bcapCaptureStop(hwnd)                       ((BOOL)BWCapSM(hwnd, WM_CAP_STOP, (WPARAM)0, (LPARAM)0L))
#define bcapCaptureAbort(hwnd)                      ((BOOL)BWCapSM(hwnd, WM_CAP_ABORT, (WPARAM)0, (LPARAM)0L))

#define bcapCaptureSingleFrameOpen(hwnd)            ((BOOL)BWCapSM(hwnd, WM_CAP_SINGLE_FRAME_OPEN, (WPARAM)0, (LPARAM)0L))
#define bcapCaptureSingleFrameClose(hwnd)           ((BOOL)BWCapSM(hwnd, WM_CAP_SINGLE_FRAME_CLOSE, (WPARAM)0, (LPARAM)0L))
#define bcapCaptureSingleFrame(hwnd)                ((BOOL)BWCapSM(hwnd, WM_CAP_SINGLE_FRAME, (WPARAM)0, (LPARAM)0L))

#define bcapCaptureGetSetup(hwnd, s, wSize)         ((BOOL)BWCapSM(hwnd, WM_CAP_GET_SEQUENCE_SETUP, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPCAPTUREPARMS)(s)))
#define bcapCaptureSetSetup(hwnd, s, wSize)         ((BOOL)BWCapSM(hwnd, WM_CAP_SET_SEQUENCE_SETUP, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPCAPTUREPARMS)(s)))

#define bcapSetMCIDeviceName(hwnd, szName)          ((BOOL)BWCapSM(hwnd, WM_CAP_SET_MCI_DEVICE, 0, (LPARAM)(LPVOID)(LPTSTR)(szName)))
#define bcapGetMCIDeviceName(hwnd, szName, wSize)   ((BOOL)BWCapSM(hwnd, WM_CAP_GET_MCI_DEVICE, (WPARAM)(wSize), (LPARAM)(LPVOID)(LPTSTR)(szName)))

#define bcapPaletteOpen(hwnd, szName)               ((BOOL)BWCapSM(hwnd, WM_CAP_PAL_OPEN, 0, (LPARAM)(LPVOID)(LPTSTR)(szName)))
#define bcapPaletteSave(hwnd, szName)               ((BOOL)BWCapSM(hwnd, WM_CAP_PAL_SAVE, 0, (LPARAM)(LPVOID)(LPTSTR)(szName)))
#define bcapPalettePaste(hwnd)                      ((BOOL)BWCapSM(hwnd, WM_CAP_PAL_PASTE, (WPARAM) 0, (LPARAM)0L))
#define bcapPaletteAuto(hwnd, iFrames, iColors)     ((BOOL)BWCapSM(hwnd, WM_CAP_PAL_AUTOCREATE, (WPARAM)(iFrames), (LPARAM)(DWORD)(iColors)))
#define bcapPaletteManual(hwnd, fGrab, iColors)     ((BOOL)BWCapSM(hwnd, WM_CAP_PAL_MANUALCREATE, (WPARAM)(fGrab), (LPARAM)(DWORD)(iColors)))


/* 
 * mpeg gop time code
 */
typedef union _MPEG_TIME_CODE {
	
	DWORD dword;
	
	struct {
	
		unsigned res  :5;
		unsigned bl   :1;
		unsigned cg   :1;
		unsigned f    :6;
		unsigned s    :6;
		unsigned fx   :1;
		unsigned m    :6;
		unsigned h    :5;
		unsigned dff  :1;

	} fld;

} MPEG_TIME_CODE;


/* 
 * mpeg temporal reference
 */
typedef union _MPEG_TEMPORAL_REFERENCE {
	
	DWORD dword;
	
	struct {
	
		unsigned res  :3;
		unsigned dly  :16;
		unsigned pt   :3;
		unsigned tr   :10;

	} fld;

} MPEG_TEMPORAL_REFERENCE;


/* 
 * realtime capture info structure 
 */
typedef struct _RTINFO {

	WAVEFORMATEX WaveFormat;
	CAPSTATUS CapStatus;	 
	CAPTUREPARMS CapParams;
	HWAVEIN hWave;
	
	char szCaptureFile[MAX_PATH];
	char szAudioCaptureFile[MAX_PATH];

	DWORD AudioEncodeIndex;
	DWORD VideoEncodeIndex;
	DWORD AudioReadyIndex;
	DWORD VideoReadyIndex;
	DWORD AudioDoneIndex;
	DWORD VideoDoneIndex;
	DWORD AudioDoneCount;
	DWORD VideoDoneCount;
	DWORD AudioByteCount;
	DWORD FrameCount;
	DWORD AudioStartCount;
	DWORD VideoStartCount;
	DWORD LastGop;
	DWORD dwStopTime;
	DWORD dwLastReference;
	DWORD dwPrevious;
	DWORD cbStart;
	DWORD dwStartTime;
	DWORD dwStopFrames;
	DWORD dwCurrentBytes;
	DWORD PFrameCount;
	DWORD FileCount;
	DWORD dwSizeGOP; 
	DWORD dwGopStartIndex;
	DWORD dwNextGopStartIndex;
	DWORD dwGopFrameCount;
	DWORD dwVideoLength;
	DWORD dwVideoFilled;
	DWORD dwVideoUnused;
	DWORD dwVideoTail;
	DWORD dwNewStartCountDown;
	DWORD dwDropCount;
	DWORD dwCurrentVideoBytes;
	DWORD dwLastTemporalReference;
	DWORD dwMaxFileSize;

	unsigned __int64 NextIPDelay;
	unsigned __int64 DecodingTime;

	EStreamMixType StreamMixType;
	EStereoType StereoType;
	ESamplingFreq SamplingFreq;

	double StreamDataRate; 
	double AudioDelay;

	HCURSOR OldCursor;

	BOOL fCaptureVideo;
	BOOL fCaptureAudio;
	BOOL bCaptureOK;
	BOOL bStreamMix;
	BOOL bFirstFrame;
	BOOL bLastFrame;
	BOOL bStop;
	BOOL bPreview;
    BOOL AudioMode;
	BOOL UseQSIF;
	BOOL StopCodeWritten;
	BOOL bGotGoodStop;
	BOOL bGotIFrame;
	BOOL bSplitFile;
	BOOL CheckDiskSpace;
	BOOL bCreateNoFile;
	BOOL bHaveFullGop;
	BOOL bFirstGop;
	BOOL bFlushToLastGOP;
	BOOL bGotStopFrame;
	BOOL bAudioDone;
	BOOL bDiskFull;

	int AudioDataRate;
	int VideoDataRate;
	int PackSize;
	int PacketsPerPack;
	int ErrorCode;
	int AudioBytesToRead;
	int MaxSB;
	
	BYTE* lpVideoBuf;
	BYTE* lpPadBuffer;
	BYTE *OutData;
	BYTE *InBuf;				   
	
	LPWAVEHDR waveHdr;
	WAVEHDR waveHdrNoFile;
	LPWAVEHDR lpProcessWaveHdr;
	LPVIDEOHDR videoHdr;
	LPVIDEOHDR lpProcessVideoHdr;
	
	HANDLE hStream;
	HANDLE hAudioPin;
	HANDLE hVideoPin;
	HANDLE hAudioEncode;
	HANDLE OutFile;
	HANDLE AudioFile;
	HANDLE tmpVideoReadFile;
	HANDLE tmpVideoWriteFile;
	HANDLE hCaptureStop;

	HDC hDC;
    HDRAWDIB hdd;

	HHOOK hHookM;
	HHOOK hHookK;

    long DstWidth;
    long DstHeight;
    long SrcWidth;
    long SrcHeight;

    BITMAPINFOHEADER biOut;
	MPEG_TIME_CODE tc;
	
	char StopCodeFrame[576];
	char sDriveLetter[20];
	char sRootName[MAX_PATH];

} RTINFO, *PRTINFO, *LPRTINFO;


#ifdef __cplusplus
extern "C" {
#endif


/* functions in capwnd.c */
LRESULT CALLBACK CapWndSubclassProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL RT_GetCaptureWindow(HWND hWndCap, CAPCALLBACKS *lpCallbacks);
BOOL RT_ReleaseCaptureWindow(HWND hWndCap);

/* functions in realtime.c */
LRESULT RT_InitializeCaptureWindow (LPHWINFO lpHw); 
LRESULT RT_CapFileGetCaptureFile (LPHWINFO lpHw, LPSTR lpszFileName, UINT nSize);
LRESULT RT_CapFileSetCaptureFile (LPHWINFO lpHw, LPSTR lpszFileName);

LRESULT RT_CapDriverGetVersion (UINT wSize, LPSTR lpVersion);
LRESULT RT_CapSetCallbackOnError (LPHWINFO lpHw, FARPROC lpfnCallback);
LRESULT RT_CapSetCallbackOnStatus (LPHWINFO lpHw, FARPROC lpfnCallback);
LRESULT RT_CapSetCallbackOnYield (LPHWINFO lpHw, FARPROC lpfnCallback);
LRESULT RT_CapSetCallbackOnVideoStream (LPHWINFO lpHw, FARPROC lpfnCallback);
LRESULT RT_CapSetCallbackOnWaveStream (LPHWINFO lpHw, FARPROC lpfnCallback);
LRESULT RT_CapSetCallbackOnCapControl (LPHWINFO lpHw, FARPROC lpfnCallback);
LRESULT RT_CapGetStatus (LPHWINFO lpHw, CAPSTATUS* lpCapStatus, UINT size);
LRESULT RT_CapPreview (LPHWINFO lpHw, BOOL bPreview);
LRESULT RT_CapGetVideoFormat (LPHWINFO lpHw, LPBITMAPINFOHEADER lpbi, UINT size);

LRESULT RT_CapCaptureSequence (LPHWINFO lpHw);
LRESULT RT_CapCaptureSequenceNoFile (LPHWINFO lpHw);
LRESULT RT_CapCaptureStop (LPHWINFO lpHw);
LRESULT RT_CapCaptureAbort (LPHWINFO lpHw);
LRESULT RT_CaptureLoop (LPHWINFO lpHw);

int RT_LoadAviCapString(LPHWINFO lpHw, UINT uID, LPTSTR lpBuffer, int nBufferMax);
long RT_GetFreeDiskSpaceInKB(LPRTINFO lpRT, LPCTSTR pFile);
BOOL RT_FlushToLastGop (LPHWINFO lpHw);

#ifdef __cplusplus
}
#endif

#endif